Index: trunk/AGRIF/LIB/fortran.y
===================================================================
--- trunk/AGRIF/LIB/fortran.y	(revision 530)
+++ trunk/AGRIF/LIB/fortran.y	(revision 663)
@@ -3,6 +3,6 @@
 /*     CONV (converter) for Agrif (Adaptive Grid Refinement In Fortran)       */
 /*                                                                            */
-/* Copyright or © or Copr. Laurent Debreu (Laurent.Debreu@imag.fr)            */
-/*                        Cyril Mazauric (Cyril.Mazauric@imag.fr)             */
+/* Copyright or   or Copr. Laurent Debreu (Laurent.Debreu@imag.fr)            */
+/*                        Cyril Mazauric (Cyril_Mazauric@yahoo.fr)            */
 /* This software is governed by the CeCILL-C license under French law and     */
 /* abiding by the rules of distribution of free software.  You can  use,      */
@@ -31,5 +31,5 @@
 /* knowledge of the CeCILL-C license and that you accept its terms.           */
 /******************************************************************************/
-/* version 1.0                                                                */
+/* version 1.6                                                                */
 /******************************************************************************/
 %{
@@ -49,5 +49,7 @@
 typedim c_selectordim;
 listcouple *coupletmp;
+listdim *parcoursdim;
 int removeline=0;
+listvar *test;
 %}
 
@@ -56,5 +58,4 @@
        listdim  *d;
        listvar  *l;
-       listvarcommon *lcom;
        listnom  *ln;
        listcouple  *lc;
@@ -81,5 +82,4 @@
 %token TOK_NEXTLINE
 %token TOK_PARAMETER
-%token TOK_KIND
 %token TOK_RESULT
 %token TOK_ONLY
@@ -103,4 +103,6 @@
 %token TOK_SELECTCASE
 %token TOK_FILE
+%token TOK_END
+%token TOK_ERR
 %token TOK_DONOTTREAT
 %token TOK_ENDDONOTTREAT
@@ -123,9 +125,9 @@
 %token TOK_TAN
 %token TOK_ATAN
+%token TOK_RECURSIVE
 %token TOK_ABS
 %token TOK_MOD
 %token TOK_SIGN
 %token TOK_MINLOC
-/*%token TOK_REC*/
 %token TOK_MAXLOC
 %token TOK_EXIT
@@ -168,6 +170,6 @@
 %token TOK_INTENT
 %token TOK_INTRINSIC
-%token TOK_NAMELIST 
-%token TOK_CASEDEFAULT 
+%token TOK_NAMELIST
+%token TOK_CASEDEFAULT
 %token TOK_OPTIONAL
 %token TOK_POINTER
@@ -175,6 +177,4 @@
 %token TOK_SAVE
 %token TOK_TARGET
-%token TOK_POINT
-%token TOK_DATA 
 %token TOK_QUOTE
 %token TOK_IMPLICIT
@@ -185,8 +185,8 @@
 %token TOK_COMMON
 %token TOK_GLOBAL
-%token TOK_INTERFACE 
-%token TOK_ENDINTERFACE 
-%token TOK_LEFTAB 
-%token TOK_RIGHTAB 
+%token TOK_INTERFACE
+%token TOK_ENDINTERFACE
+%token TOK_LEFTAB
+%token TOK_RIGHTAB
 %token TOK_PAUSE
 %token TOK_PROCEDURE
@@ -207,8 +207,9 @@
 %token <na> TOK_NOT
 %token <na> TOK_AND
-%token <na> TOK_TRUE 
-%token <na> TOK_FALSE 
+%token <na> TOK_TRUE
+%token <na> TOK_FALSE
 %token <na> TOK_LABEL
 %token <na> TOK_TYPE
+%token <na> TOK_TYPEPAR
 %token <na> TOK_ENDTYPE
 %token <na> TOK_REAL
@@ -224,10 +225,11 @@
 %token <na> TOK_CHAR_CONSTANT
 %token <na> TOK_CHAR_CUT
+%token <na> TOK_DATA
 %token <na> TOK_CHAR_INT
-%token <na> TOK_CHAR_MESSAGE 
+%token <na> TOK_CHAR_MESSAGE
 %token <na> TOK_CSTREAL
 %token <na> TOK_CSTREALDP
 %token <na> TOK_CSTREALQP
-%token <na> TOK_SFREAL 
+%token <na> TOK_SFREAL
 %token <na> TOK_COMPLEX
 %token <na> TOK_DOUBLECOMPLEX
@@ -242,5 +244,5 @@
 %token <na> TOK_OP
 %token <na> TOK_CSTINT
-%token <na> TOK_COMMENT 
+%token <na> TOK_COMMENT
 %token <na> TOK_FILENAME
 %token ','
@@ -248,22 +250,21 @@
 %token ':'
 %token '('
-%token ')'   
+%token ')'
 %token '['
 %token ']'
 %token '!'
-%token '_' 
-%token '<' 
-%token '>' 
+%token '_'
+%token '<'
+%token '>'
 %type <l> dcl
+%type <l> after_type
 %type <l> dimension
 %type <l> paramlist
-%type <l> args  
+%type <l> args
+%type <l> arglist
 %type <lc> only_list
 %type <lc> only_name
 %type <lc> rename_list
 %type <lc> rename_name
-%type <lcom> common
-%type <lcom> var_common
-%type <lcom> var_common_list
 %type <d> dims
 %type <d> dimlist
@@ -286,28 +287,32 @@
 %type <na> simple_const
 %type <na> vec
-%type <na> outlist 
-%type <na> out2 
-%type <na> other 
-%type <na> dospec 
-%type <na> expr_data 
-%type <na> beforefunctionuse 
-%type <na> ident 
-%type <na> structure_component 
-%type <na> array_ele_substring_func_ref  
-%type <na> funarglist  
-%type <na> funarg  
-%type <na> funargs  
-%type <na> triplet  
-%type <na> substring  
-%type <na> string_constant  
-%type <na> opt_substring  
-%type <na> opt_expr  
-%type <na> optexpr  
-%type <na> datavallist  
-%type <na> after_slash  
+%type <na> outlist
+%type <na> out2
+%type <na> other
+%type <na> dospec
+%type <na> expr_data
+%type <na> beforefunctionuse
+%type <na> ident
+%type <na> structure_component
+%type <na> array_ele_substring_func_ref
+%type <na> funarglist
+%type <na> funarg
+%type <na> funargs
+%type <na> triplet
+%type <na> substring
+%type <na> string_constant
+%type <na> opt_substring
+%type <na> opt_expr
+%type <na> optexpr
+%type <na> datavallist
+%type <na> after_slash
 %type <na> after_equal
 %type <na> predefinedfunction
-%type <na> do_var  
+%type <na> do_var
 %type <na> expr
+%type <na> word_endsubroutine
+%type <na> word_endfunction
+%type <na> word_endprogram
+%type <na> word_endunit
 %type <na> intent_spec
 %type <na> ubound
@@ -328,5 +333,5 @@
       | keyword cmnt writedeclar
       | error writedeclar nulcurbuf
-                   {yyerrok;yyclearin;}    
+                   {yyerrok;yyclearin;}
       ;
 suite_line_list : suite_line
@@ -337,6 +342,5 @@
       | before_include filename fin_line
                   {
-                     if (inmoduledeclare == 0 && 
-                         couldaddvariable == 1 )
+                     if (inmoduledeclare == 0 )
                      {
                         pos_end = setposcur();
@@ -346,5 +350,5 @@
                   }
       | exec cmnt writedeclar /* if, do etc ...                               */
-      | instr fin_line    /* instruction ident : do i = 1 ...                 */
+      | instr fin_line    /* instruction ident  : do i = 1 ...                */
       ;
 instr : ident ':'
@@ -352,12 +356,12 @@
 fin_line : position cmnt
       ;
-keyword : TOK_DONOTTREAT 
+keyword : TOK_DONOTTREAT
          {
-            /* we should ignore the declaration until the keyword   */
-            /*    TOK_ENDDONOTTREAT                                 */
+            /* we should ignore the declaration until the keyword             */
+            /*    TOK_ENDDONOTTREAT                                           */
             couldaddvariable = 0 ;
             RemoveWordCUR_0(fortranout,-20,20);
          }
-      | TOK_ENDDONOTTREAT 
+      | TOK_ENDDONOTTREAT
          {
              couldaddvariable = 1 ;
@@ -369,5 +373,5 @@
 position: {pos_cur = setposcur();}
       ;
-thislabel: 
+thislabel:
       | TOK_LABEL nulcurbuf
       ;
@@ -381,137 +385,129 @@
                    {if (incom !=1) {strcpy(curbuf,"");incom=0;}}
       ;
-entry: 
-      | TOK_SUBROUTINE name_routine arglist
-                   {
-                      Listofvariableinagriffunction=(listnom *)NULL;
-                      strcpy(subroutinename,$2);
+opt_recursive :
+      | TOK_RECURSIVE
+      ;
+entry:
+      | opt_recursive TOK_SUBROUTINE name_routine arglist
+                   {
+                      if ( couldaddvariable == 1 )
+                      {
+                      /* open param file                                      */
+                      if ( firstpass == 0 )
+                      {
+                         sprintf(ligne,"%s/ParamFile%s.h",nomdir,$3);
+                         paramout=fopen(ligne,"w");
+                         if ( retour77 == 0 ) fprintf(paramout,"!\n");
+                         else fprintf(paramout,"C\n");
+
+                      }
+                      Add_SubroutineArgument_Var_1($4);
                       if ( inmodulemeet == 1 )
                       {
-                         tmpdeclaration_everdone = 0;
-                         paramdeclaration_everdone = 0;
                          insubroutinedeclare = 1;
-                         AddUseAgrifUtil_0();
                          /* in the second step we should write the head of    */
                          /*    the subroutine sub_loop_<subroutinename>       */
                          writeheadnewsub_0(1);
-                         adduseagrifutil = 0 ; 
                       }
                       else
                       {
-                            tmpdeclaration_everdone = 0;
-                            paramdeclaration_everdone = 0;
                             insubroutinedeclare = 1;
-                            AddUseAgrifUtil_0();
                             writeheadnewsub_0(1);
-                            adduseagrifutil = 0 ; 
+                      }
                       }
                    }
       | TOK_PROGRAM name_routine
                    {
-                      Listofvariableinagriffunction=(listnom *)NULL;
+                      /* open param file                                      */
+                      if ( firstpass == 0 )
+                      {
+                         sprintf(ligne,"%s/ParamFile%s.h",nomdir,$2);
+                         paramout=fopen(ligne,"w");
+                         if ( retour77 == 0 ) fprintf(paramout,"!\n");
+                         else fprintf(paramout,"C\n");
+
+                      }
                       strcpy(subroutinename,$2);
                       /* Common case                                          */
-                         tmpdeclaration_everdone = 0;
-                         paramdeclaration_everdone = 0;
-                         insubroutinedeclare = 1;
-                         AddUseAgrifUtil_0();
-                         /* in the second step we should write the head of    */
-                         /*    the subroutine sub_loop_<subroutinename>       */
-                         writeheadnewsub_0(1);
-                         adduseagrifutil = 0 ;                       
+                      insubroutinedeclare = 1;
+                      /* in the second step we should write the head of       */
+                      /*    the subroutine sub_loop_<subroutinename>          */
+                      writeheadnewsub_0(1);
                    }
       | TOK_FUNCTION name_routine arglist TOK_RESULT arglist1
                    {
-                      Listofvariableinagriffunction=(listnom *)NULL;
+                      /* open param file                                      */
+                      if ( firstpass == 0 )
+                      {
+                         sprintf(ligne,"%s/ParamFile%s.h",nomdir,$2);
+                         paramout=fopen(ligne,"w");
+                         if ( retour77 == 0 ) fprintf(paramout,"!\n");
+                         else fprintf(paramout,"C\n");
+                      }
                       strcpy(subroutinename,$2);
                       if ( inmodulemeet == 1 )
                       {
-                         tmpdeclaration_everdone = 0;
-                         paramdeclaration_everdone = 0;
                          insubroutinedeclare = 1;
-                         AddUseAgrifUtil_0();
                          /* we should to list of the subroutine argument the  */
                          /*    name of the function which has to be defined   */
-                         if ( firstpass == 1 ) 
-                         {
-                            curvar=createvar($2,NULL);
-                            curlistvar=insertvar(NULL,curvar);
-                            listargsubroutine = AddListvarToListvar(curlistvar,listargsubroutine,1);
-                         }
+                         Add_SubroutineArgument_Var_1($3);
+                         strcpy(DeclType,"");
                          /* in the second step we should write the head of    */
                          /*    the subroutine sub_loop_<subroutinename>       */
                          writeheadnewsub_0(2);
-                         adduseagrifutil = 0 ; 
                       }
                       else
                       {
-                            tmpdeclaration_everdone = 0;
-                            paramdeclaration_everdone = 0;
                             insubroutinedeclare = 1;
-                            AddUseAgrifUtil_0();
                             /* we should to list of the subroutine argument   */
                             /* name of the function which has to be defined   */
-                            if ( firstpass == 1 ) 
-                            {
-                               curvar=createvar($2,NULL);
-                               curlistvar=insertvar(NULL,curvar);
-                               listargsubroutine = AddListvarToListvar
-                                               (curlistvar,listargsubroutine,1);
-                            }
+                            Add_SubroutineArgument_Var_1($3);
+                            strcpy(DeclType,"");
+                            Add_FunctionType_Var_1($2);
                             writeheadnewsub_0(2);
-                            adduseagrifutil = 0 ; 
                       }
                    }
       | TOK_FUNCTION name_routine arglist
                    {
-                      Listofvariableinagriffunction=(listnom *)NULL;
+                      /* open param file                                      */
+                      if ( firstpass == 0 )
+                      {
+                         sprintf(ligne,"%s/ParamFile%s.h",nomdir,$2);
+                         paramout=fopen(ligne,"w");
+                         if ( retour77 == 0 ) fprintf(paramout,"!\n");
+                         else fprintf(paramout,"C\n");
+                      }
                       strcpy(subroutinename,$2);
                       if ( inmodulemeet == 1 )
                       {
-                         tmpdeclaration_everdone = 0;
-                         paramdeclaration_everdone = 0;
                          insubroutinedeclare = 1;
-                         AddUseAgrifUtil_0();
                          /* we should to list of the subroutine argument the  */
                          /*    name of the function which has to be defined   */
-                         if ( firstpass == 1 ) 
-                         {
-                            curvar=createvar($2,NULL);
-                            curlistvar=insertvar(NULL,curvar);
-                            listargsubroutine = AddListvarToListvar
-                                               (curlistvar,listargsubroutine,1);
-                         }
+                         Add_SubroutineArgument_Var_1($3);
+                         strcpy(DeclType,"");
+                         Add_FunctionType_Var_1($2);
                          /* in the second step we should write the head of    */
                          /*    the subroutine sub_loop_<subroutinename>       */
                          writeheadnewsub_0(2);
-                         adduseagrifutil = 0 ; 
                       }
                       else
                       {
-                            tmpdeclaration_everdone = 0;
-                            paramdeclaration_everdone = 0;
                             insubroutinedeclare = 1;
-                            AddUseAgrifUtil_0();
                             /* we should to list of the subroutine argument   */
                             /* name of the function which has to be defined   */
-                            if ( firstpass == 1 ) 
-                            {
-                               curvar=createvar($2,NULL);
-                               curlistvar=insertvar(NULL,curvar);
-                               listargsubroutine = AddListvarToListvar
-                                               (curlistvar,listargsubroutine,1);
-                            }
+                            Add_SubroutineArgument_Var_1($3);
+                            strcpy(DeclType,"");
+                            Add_FunctionType_Var_1($2);
                             writeheadnewsub_0(2);
-                            adduseagrifutil = 0 ; 
                       }
                    }
       | TOK_MODULE TOK_NAME
                    {
+                      GlobalDeclaration = 0;
                       strcpy(curmodulename,$2);
-                      Add_ModuleTo_Modulelist_1($2);
+                      strcpy(subroutinename,"");
+                      Add_NameOfModule_1($2);
                       if ( inmoduledeclare == 0 )
-                      { 
-                         /* Alloc should be create ?                          */
-                         FillInlistmodule_1();   
+                      {
                          /* To know if there are in the module declaration    */
                          inmoduledeclare = 1;
@@ -520,10 +516,14 @@
                          /* to know if we are after the keyword contains      */
                          aftercontainsdeclare = 0 ;
-                      }      
-                      /* WE should use Agrif_Util if it is necessary          */
-                      AddUseAgrifInModuleDeclaration_0();
-                   }
-      ;
-name_routine : TOK_NAME {strcpy($$,$1);strcpy(subroutinename,$1);}
+                      }
+                   }
+      ;
+name_routine : TOK_NAME
+                   {
+                      if ( couldaddvariable == 1 )
+                      {
+                         strcpy($$,$1);strcpy(subroutinename,$1);
+                      }
+                   }
 writedeclar :
       ;
@@ -531,102 +531,107 @@
                    {
                       pos_curinclude = setposcur()-9;
-                   }      
+                   }
 filename: TOK_CHAR_CONSTANT
                    {
-                      if ( couldaddvariable == 1 )
-                      {
-                         Addincludetothelist_1($1);
-                      }                   
-                   }
-      ;
-arglist: 
+                      if ( couldaddvariable == 1 ) Add_Include_1($1);
+                   }
+      ;
+arglist:           {
+                      if ( firstpass == 1 && couldaddvariable == 1) $$=NULL;
+                   }
       | '(' ')'    {
-                      if ( firstpass == 1 ) listargsubroutine=NULL;
+                      if ( firstpass == 1 && couldaddvariable == 1 ) $$=NULL;
                    }
       | '(' args ')'
                    {
-                       if ( firstpass == 1 ) listargsubroutine=$2;
-                   }
-      ;
-arglist1: 
+                       if ( firstpass == 1 && couldaddvariable == 1 ) $$=$2;
+                   }
+      ;
+arglist1:
       | '(' ')'
       | '(' args ')'
                    {
-                       listargsubroutine = AddListvarToListvar
-                                                       ($2,listargsubroutine,1);
+                      if ( couldaddvariable == 1 )
+                      {
+                         Add_SubroutineArgument_Var_1($2);
+                      }
                    }
       ;
 args:arg           {
-                      if ( firstpass == 1 )
-                      {
-                         curvar=createvar($1,curdim);
+                      if ( firstpass == 1  && couldaddvariable == 1)
+                      {
+                         curvar=createvar($1,NULL);
                          curlistvar=insertvar(NULL,curvar);
-                         $$=settype($1,curlistvar);
-                      }
-                   }
-      | args ',' arg 
-                   {
-                      if ( firstpass == 1 )
-                      {
-                         curvar=createvar($3,curdim);
+                         $$=settype("",curlistvar);
+                      }
+                   }
+      | args ',' arg
+                   {
+                      if ( firstpass == 1  && couldaddvariable == 1)
+                      {
+                         curvar=createvar($3,NULL);
                          $$=insertvar($1,curvar);
                       }
                    }
       ;
-arg: TOK_NAME      {strcpy($$,$1);}
-      | '*'        {strcpy($$,"*");}
-      ; 
+arg: TOK_NAME      {if ( couldaddvariable == 1 ) strcpy($$,$1);}
+      | '*'        {if ( couldaddvariable == 1 ) strcpy($$,"*");}
+      ;
 spec: type after_type
                    {
-                      /* remove declaration                                   */
-                      if ( fortran77 == 1                       && 
-                           infunctiondeclare == 0               && 
-                           commonlist                           && 
-                           IsTabvarsUseInArgument_0() == 1      &&
-                           couldaddvariable == 1 ) 
-                      {
+                      if ( VarTypepar == 1 )
+                      {
+                         couldaddvariable = 1 ;
+                         VarTypepar = 0;
+                      }
+                   }
+      | TOK_TYPE opt_spec opt_sep opt_name
+                   {
+                      if ( couldaddvariable == 1 )
+                      {
+                         VarType = 1;
+                         couldaddvariable = 0 ;
+                      }
+                   }
+      | TOK_ENDTYPE opt_name
+                   {
+                      if ( VarType == 1 ) couldaddvariable = 1 ;
+                      VarType = 0;
+                      VarTypepar = 0;
+                   }
+      | TOK_POINTER list_couple
+      | before_parameter  '(' paramlist ')'
+                   {
+                      if ( couldaddvariable == 1 )
+                      {
+                         if ( insubroutinedeclare == 0 )
+                                                  Add_GlobalParameter_Var_1($3);
+                         else Add_Parameter_Var_1($3);
                          pos_end = setposcur();
                          RemoveWordSET_0(fortranout,pos_cur_decl,
-                                               pos_end-pos_cur_decl);
-                      }
-                      infunctiondeclare = 0 ;
-                   }
-      | TOK_TYPE opt_name
-/*      {
-         couldaddvariable = 0;
-      }*/
-      | TOK_ENDTYPE opt_name
-/*      {
-         couldaddvariable = 1;
-      }*/
-      | TOK_POINTER list_couple
-      | before_parameter  '(' paramlist ')' 
-                   {
-                      AddvartoParamlist_1($3);
-                      if ( fortran77 == 1  && 
-                           commonlist      && 
-                           listvarindoloop && 
-                           IsTabvarsUseInArgument_0() == 1 )
-                      {
+                                                    pos_end-pos_cur_decl);
+                      }
+                      VariableIsParameter =  0 ;
+                   }
+      | before_parameter  paramlist
+                   {
+                     if ( couldaddvariable == 1 )
+                     {
+                        if ( insubroutinedeclare == 0 )
+                                                  Add_GlobalParameter_Var_1($2);
+                         else Add_Parameter_Var_1($2);
                          pos_end = setposcur();
-                         RemoveWordSET_0(fortranout,pos_curparameter,
-                                               pos_end-pos_curparameter);
-                      }
-                   }
-      | before_parameter  paramlist 
-                   {
-                      AddvartoParamlist_1($2);
-                      if ( fortran77 == 1  && 
-                           commonlist      && 
-                           listvarindoloop && 
-                           IsTabvarsUseInArgument_0() == 1 )
-                      {
-                         pos_end = setposcur();
-                         RemoveWordSET_0(fortranout,pos_curparameter,
-                                               pos_end-pos_curparameter);
-                      }
+                         RemoveWordSET_0(fortranout,pos_cur_decl,
+                                                    pos_end-pos_cur_decl);
+                      }
+                      VariableIsParameter =  0 ;
                    }
       | common
       | save
+                  {
+                     pos_end = setposcur();
+                     RemoveWordSET_0(fortranout,pos_cursave,
+                                                pos_end-pos_cursave);
+                  }
       | implicit
       | dimension
@@ -637,23 +642,24 @@
                       if ( couldaddvariable == 1 )
                       {
-                         ajoutevar_1($1);
-                         NonGridDepDeclaration_0($1);
-                         /* if variables has been declared in a subroutine    */
+                         Add_Globliste_1($1);
+                         /* if variableparamlists has been declared in a      */
+                         /*    subroutine                                     */
                          if ( insubroutinedeclare == 1 )
                          {
-                           ajoutvarofsubroutine_1($1);
-                           writesubroutinedeclaration_0($1);
+                            Add_Dimension_Var_1($1);
                          }
-                      }
-                      /* Case of common block                                 */
-                      indeclarationvar=0;
-                      PublicDeclare = 0;  
-                      PrivateDeclare = 0; 
-                      ExternalDeclare = 0; 
-                      strcpy(NamePrecision,"");  
+                         pos_end = setposcur();
+                         RemoveWordSET_0(fortranout,pos_curdimension,
+                                                pos_end-pos_curdimension);
+                      }
+                      /*                                                      */
+                      PublicDeclare = 0;
+                      PrivateDeclare = 0;
+                      ExternalDeclare = 0;
+                      strcpy(NamePrecision,"");
                       c_star = 0;
                       InitialValueGiven = 0 ;
                       strcpy(IntentSpec,"");
-                      VariableIsParameter =  0 ; 
+                      VariableIsParameter =  0 ;
                       Allocatabledeclare = 0 ;
                       SaveDeclare = 0;
@@ -662,5 +668,6 @@
                       dimsgiven=0;
                       c_selectorgiven=0;
-                      strcpy(nameinttypename,"");  
+                      strcpy(nameinttypename,"");
+                      strcpy(c_selectorname,"");
                    }
       | public
@@ -668,20 +675,27 @@
       | use_stat
       | module_proc_stmt
-      | interface 
+      | interface
       | namelist
       | TOK_BACKSPACE '(' expr ')'
       | TOK_EXTERNAL opt_sep use_name_list
       | TOK_INTRINSIC opt_sep use_intrinsic_list
-      | TOK_EQUIVALENCE '(' list_expr ')'
+      | TOK_EQUIVALENCE list_expr_equi
       | before_data data '\n'
                    {
                       /* we should remove the data declaration                */
-                     if ( aftercontainsdeclare == 0 )
-                     {
+                      if ( couldaddvariable == 1 && aftercontainsdeclare == 0 )
+                      {
                         pos_end = setposcur();
                         RemoveWordSET_0(fortranout,pos_curdata,
                                               pos_end-pos_curdata);
-                     }
+                      }
                   }
+      ;
+opt_spec :
+      | access_spec
+      {
+         PublicDeclare = 0 ;
+         PrivateDeclare = 0 ;
+      }
       ;
 name_intrinsic : TOK_SUM
@@ -712,27 +726,60 @@
 use_intrinsic_list : name_intrinsic
       | use_intrinsic_list ',' name_intrinsic
-list_couple : '(' list_expr ')' 
-      | list_couple ',' '(' list_expr ')' 
+      ;
+list_couple : '(' list_expr ')'
+      | list_couple ',' '(' list_expr ')'
+      ;
+list_expr_equi : expr_equi
+      | list_expr_equi ',' expr_equi
+      ;
+expr_equi : '(' list_expr_equi1 ')'
+      ;
+list_expr_equi1 : ident dims
+      | list_expr_equi1 ',' ident dims
+      ;
 list_expr : expr
       | list_expr ',' expr
+      ;
 opt_sep :
       | ':' ':'
       ;
-after_type : dcl nodimsgiven 
-                   {
-                   /* if the variable is a parameter we can suppose that is   */
-                   /*    value is the same on each grid. It is not useless to */
-                   /*    create a copy of it on each grid                     */
+after_type : dcl nodimsgiven
+                   {
+                      /* if the variable is a parameter we can suppose that is*/
+                      /*    value is the same on each grid. It is not useless */
+                      /*    to create a copy of it on each grid               */
                       if ( couldaddvariable == 1 )
                       {
-                         ajoutevar_1($1);
-                         if ( VariableIsParameter == 1 ) globparam =
-                                            AddListvarToListvar($1,globparam,1);
-                         NonGridDepDeclaration_0($1);
+                      pos_end = setposcur();
+                      RemoveWordSET_0(fortranout,pos_cur_decl,
+                                                 pos_end-pos_cur_decl);
+                      if ( firstpass == 0 &&
+                           GlobalDeclaration == 0 &&
+                           insubroutinedeclare == 0 )
+                      {
+                         sprintf(ligne,"\n#include \"Module_Declar_%s.h\"\n"
+                                                                ,curmodulename);
+                         tofich(fortranout,ligne,1);
+                         sprintf (ligne, "Module_Declar_%s.h",curmodulename);
+                         module_declar = associate(ligne);
+                         sprintf (ligne, " ");
+                         tofich (module_declar, ligne,1);
+                         GlobalDeclaration = 1 ;
+                      }
+                         $$ = $1;
+                         Add_Globliste_1($1);
+                         if ( insubroutinedeclare == 0 )
+                                                  Add_GlobalParameter_Var_1($1);
+                         else
+                         {
+                            if ( pointerdeclare == 1 )
+                                                Add_Pointer_Var_From_List_1($1);
+                            Add_Parameter_Var_1($1);
+                         }
+
                          /* if variables has been declared in a subroutine    */
                          if ( insubroutinedeclare == 1 )
                          {
-                           ajoutvarofsubroutine_1($1);
-                           writesubroutinedeclaration_0($1);
+                           Add_SubroutineDeclaration_Var_1($1);
                          }
                          /* If there are a SAVE declarations in module's      */
